summaryrefslogtreecommitdiffstats
path: root/src/dir.sh
diff options
context:
space:
mode:
Diffstat (limited to 'src/dir.sh')
-rw-r--r--src/dir.sh56
1 files changed, 56 insertions, 0 deletions
diff --git a/src/dir.sh b/src/dir.sh
new file mode 100644
index 0000000..338d8fe
--- /dev/null
+++ b/src/dir.sh
@@ -0,0 +1,56 @@
+# Miscellaneous directory-related functions
+#
+# Copyright (C) 2013 Patrick "P. J." McDermott
+#
+# This file is part of the ProteanOS Development Kit.
+#
+# The ProteanOS Development Kit is free software: you can redistribute
+# it and/or modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# The ProteanOS Development Kit is distributed in the hope that it
+# will be useful, but WITHOUT ANY WARRANTY; without even the implied
+# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+# See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with the ProteanOS Development Kit. If not, see
+# <http://www.gnu.org/licenses/>.
+
+dir_is_empty()
+{
+ local dir="${1}"
+ local ret=
+ local dirent=
+ local exclude=
+ local exclusion=
+ shift 1
+
+ ret=0
+
+ # Patterns to match all dirents except "." and "..":
+ # * dirents whose names don't start with "."
+ # .[!.] dirents whose names start with ".", are two characters long,
+ # and aren't ".."
+ # .??* dirents whose names start with "." and are three or more
+ # characters long
+ for dirent in "${dir}/"* "${dir}/".[!.] "${dir}/".[!.] "${dir}/".??*; do
+ if ! [ -e "${dirent}" ]; then
+ continue
+ fi
+ exclude=false
+ for exclusion in "${@}"; do
+ if [ "x${dirent##*/}" = "x${exclusion}" ]; then
+ exclude=true
+ break
+ fi
+ done
+ if ! ${exclude}; then
+ ret=1
+ break
+ fi
+ done
+
+ return ${ret}
+}